// Code generated by OpenAPI Generator (https://openapi-generator.tech), manual changes will be lost - read more on https://github.com/algolia/api-clients-automation. DO NOT EDIT.

import type { Exhaustive } from './exhaustive';
import type { FacetStats } from './facetStats';
import type { Redirect } from './redirect';
import type { RenderingContent } from './renderingContent';

export type BaseSearchResponse = Record<string, any> & {
  /**
   * A/B test ID. This is only included in the response for indices that are part of an A/B test.
   */
  abTestID?: number;

  /**
   * Variant ID. This is only included in the response for indices that are part of an A/B test.
   */
  abTestVariantID?: number;

  /**
   * Computed geographical location.
   */
  aroundLatLng?: string;

  /**
   * Distance from a central coordinate provided by `aroundLatLng`.
   */
  automaticRadius?: string;

  exhaustive?: Exhaustive;

  /**
   * See the `facetsCount` field of the `exhaustive` object in the response.
   */
  exhaustiveFacetsCount?: boolean;

  /**
   * See the `nbHits` field of the `exhaustive` object in the response.
   */
  exhaustiveNbHits?: boolean;

  /**
   * See the `typo` field of the `exhaustive` object in the response.
   */
  exhaustiveTypo?: boolean;

  /**
   * Facet counts.
   */
  facets?: Record<string, Record<string, number>>;

  /**
   * Statistics for numerical facets.
   */
  facets_stats?: Record<string, FacetStats>;

  /**
   * Index name used for the query.
   */
  index?: string;

  /**
   * Index name used for the query. During A/B testing, the targeted index isn\'t always the index used by the query.
   */
  indexUsed?: string;

  /**
   * Warnings about the query.
   */
  message?: string;

  /**
   * Number of hits selected and sorted by the relevant sort algorithm.
   */
  nbSortedHits?: number;

  /**
   * Post-[normalization](https://www.algolia.com/doc/guides/managing-results/optimize-search-results/handling-natural-languages-nlp/#what-does-normalization-mean) query string that will be searched.
   */
  parsedQuery?: string;

  /**
   * Time the server took to process the request, in milliseconds.
   */
  processingTimeMS: number;

  /**
   * Experimental. List of processing steps and their times, in milliseconds. You can use this list to investigate performance issues.
   */
  processingTimingsMS?: Record<string, unknown>;

  /**
   * Markup text indicating which parts of the original query have been removed to retrieve a non-empty result set.
   */
  queryAfterRemoval?: string;

  redirect?: Redirect;

  renderingContent?: RenderingContent;

  /**
   * Time the server took to process the request, in milliseconds.
   */
  serverTimeMS?: number;

  /**
   * Host name of the server that processed the request.
   */
  serverUsed?: string;

  /**
   * An object with custom data.  You can store up to 32kB as custom data.
   */
  userData?: Record<string, unknown>;

  /**
   * Unique identifier for the query. This is used for [click analytics](https://www.algolia.com/doc/guides/analytics/click-analytics/).
   */
  queryID?: string;
};
