// Code generated by OpenAPI Generator (https://openapi-generator.tech), manual changes will be lost - read more on https://github.com/algolia/api-clients-automation. DO NOT EDIT.

import type { MatchedGeoLocation } from './matchedGeoLocation';
import type { Personalization } from './personalization';

/**
 * Object with detailed information about the record\'s ranking.
 */
export type RankingInfo = {
  /**
   * Whether a filter matched the query.
   */
  filters?: number;

  /**
   * Position of the first matched word in the best matching attribute of the record.
   */
  firstMatchedWord: number;

  /**
   * Distance between the geo location in the search query and the best matching geo location in the record, divided by the geo precision (in meters).
   */
  geoDistance: number;

  /**
   * Precision used when computing the geo distance, in meters.
   */
  geoPrecision?: number;

  matchedGeoLocation?: MatchedGeoLocation;

  personalization?: Personalization;

  /**
   * Number of exactly matched words.
   */
  nbExactWords: number;

  /**
   * Number of typos encountered when matching the record.
   */
  nbTypos: number;

  /**
   * Whether the record was promoted by a rule.
   */
  promoted?: boolean;

  /**
   * Number of words between multiple matches in the query plus 1. For single word queries, `proximityDistance` is 0.
   */
  proximityDistance?: number;

  /**
   * Overall ranking of the record, expressed as a single integer. This attribute is internal.
   */
  userScore: number;

  /**
   * Number of matched words.
   */
  words?: number;

  /**
   * Whether the record is re-ranked.
   */
  promotedByReRanking?: boolean;
};
